---
- name: Import cluster role first
  import_role:
    name: cluster

- name: Check for Kube Config
  stat:
    path: "{{ remote_kubeconfig_path }}"
  register: config_status

- debug:
    msg: "Config exists: {{ config_status.stat.exists }}"
    verbosity: 1

- name: Redeploy warning to prevent overwriting a previous deployment
  include_tasks:
    file: redeploy_check.yml

- block:
  - name: Run Terraform GKE
    import_role:
      name: gke-cluster
    when: cloud_provider == "google"

  - name: Run Terraform EKS
    import_role:
      name: eks-cluster
    when: cloud_provider == "aws"

  - name: Run Terraform AKS
    import_role:
      name: aks-cluster
    when: cloud_provider == "azure"

  - name: look for kube config
    command: ls -a ~/.kube
    register: output

  - name: Make config dir
    file:
      path: "{{ remote_kubeconfig_path | dirname }}"
      state: directory

  - name: Persist Kube Config
    copy:
      src: /root/.kube/config
      remote_src: yes
      dest: "{{ remote_kubeconfig_path }}"

  - name: Save Terraform Output
    copy:
      content: "{{ terraform_outputs | to_nice_json }}"
      dest: "{{ (facts_dir, 'terraform_outputs.fact') | path_join }}"
  when: not config_status.stat.exists
